from time import sleep
import numpy as np
from pyjuni.robodog import *

from 시간 import *
from 음악 import *
from 인사 import *
from 몸짓 import *
from 앉기 import *
from 파도타기 import *
from 물구나무서기 import *
from 헤드LED메세지 import *

def leg_shake(dogs, what, loop, height, step, duration):
    speed = duration/(loop*2)
    for n in range(loop):
        multi_leg(dogs, what, height[0], step[0])
        sleep(speed)
        multi_leg(dogs, what, height[1], step[1])
        sleep(speed)

def motor_shake(dogs, what, loop, shoulder, knee, duration):
    speed = duration/(loop*2)
    sh_diff = abs(shoulder[0]-shoulder[1])
    kn_diff = abs(knee[0]-knee[1])
    
    sh_speed = 100 if sh_diff > kn_diff else int(100*sh_diff/kn_diff);
    kn_diff = 100 if kn_diff > sh_diff else int(100*kn_diff/sh_diff);

    for n in range(loop):
        multi_motor(dogs, what, shoulder[0], knee[0], shld_speed=sh_speed, knee_speed=kn_diff)
        sleep(speed)
        multi_motor(dogs, what, shoulder[1], knee[1], shld_speed=sh_speed, knee_speed=kn_diff)
        sleep(speed)


if __name__ == "__main__":
    robodogs = RoboDogMultiOpen()

    multi_leg(robodogs, ALL_LEG, height=60, step=0, height_speed=100, step_speed=100)

    sleep(0.5)
    set_start_time()

    ledPrint(robodogs, b'Hello !!')
    인사(robodogs)
    multi_leg(robodogs, ALL_LEG, height=60, step=0, height_speed=100, step_speed=100)
    wait_until(5)
    
    음악(r'music2.mp3', start_time=0)

    for n in range(len(robodogs)):
        robodogs[n].headLEDExp(13)

    leg_shake(robodogs, ALL_LEG, loop=2, height=[30, 60], step=[0, 0], duration=1)
    leg_shake(robodogs, FRONT_LEG, loop=2, height=[60, 60], step=[-40, 0], duration=1)
    leg_shake(robodogs, BACK_LEG, loop=2, height=[60, 60], step=[40, 0], duration=1)
    leg_shake(robodogs, ALL_LEG, loop=2, height=[30, 60], step=[0, 0], duration=1)

    파도타기(robodogs, loop=2, high=60, low=30, duration=3.5)
    sleep(0.5)

    몸짓(robodogs, degree=[-90, -270], duration=1.5)
    sleep(0.5)
    몸짓(robodogs, degree=[-270, -90], duration=1.5)
    sleep(0.5)

    leg_shake(robodogs, ALL_LEG, loop=2, height=[30, 60], step=[0, 0], duration=1)
    multi_rotate(robodogs, degree=0)
    wait_until(19)

    앉기(robodogs)
    multi_motor(robodogs, FRONT_LEG, -90, 70)
    motor_shake(robodogs, FRONT_LEG, loop=1, shoulder=[10,-90], knee=[-90, 70], duration=0.7)
    sleep(0.3)
    motor_shake(robodogs, FRONT_LEG, loop=2, shoulder=[10,-90], knee=[-90, 70], duration=1)
    sleep(0.5)
    multi_motor(robodogs, FRONT_LEG, shoulder=0, knee=70)
    sleep(0.5)
    motor_shake(robodogs, FRONT_LEG, loop=1, shoulder=[90,0], knee=[-90, 70], duration=0.7)
    sleep(0.3)
    motor_shake(robodogs, FRONT_LEG, loop=2, shoulder=[90, 0], knee=[-90, 70], duration=1)
    sleep(0.5)
    앉기_되돌리기(robodogs)
    wait_until(30)

    물구나무서기(robodogs)
    multi_motor(robodogs, BACK_LEG, -90, 70)
    sleep(0.5)
    
    motor_shake(robodogs, BACK_LEG, loop=1, shoulder=[0,-90], knee=[-90, 70], duration=0.7)
    sleep(0.3)
    motor_shake(robodogs, BACK_LEG, loop=2, shoulder=[0,-90], knee=[-90, 70], duration=1)
    sleep(0.5)
    multi_motor(robodogs, BACK_LEG, shoulder=0, knee=70)
    sleep(0.5)
    motor_shake(robodogs, BACK_LEG, loop=1, shoulder=[-90,0], knee=[-90, 70], duration=1.2)
    sleep(0.3)
    motor_shake(robodogs, BACK_LEG, loop=2, shoulder=[-90, 0], knee=[-90, 70], duration=2)
    sleep(0.5)
    multi_motor(robodogs, BACK_LEG, shoulder=-90, knee=-90)
    sleep(0.5)
    물구나무_되돌리기(robodogs)
    print("run time : ", get_run_time())

    RoboDogMultiClose(robodogs)
